#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;

int n, m, u, v, ans;
bool foundCycle;
bool used[5005];

struct edg
{
    int s;
    int e;
    bool isCycle;

    bool operator <(edg A) const{
        if(s == A.s){
            return e < A.e;
        }
        return s < A.s;
    }

};

vector<edg> edges;
vector<pair<int, bool> > sys[5005];


void bin_src(int a, int b)
{
    int l = 0;
    int r = m-1;
    while(r-l > 0){
        int mid = (r+l)/2;
        if(edges[mid].s < a){
            l = mid+1;
            continue;
        }
        if(edges[mid].s > a){
            r = mid - 1;
            continue;
        }
        if(edges[mid].e < b){
            l = mid + 1;
            continue;
        }
        if(edges[mid].e > b){
            r = mid - 1;
            continue;
        }
        l = mid;
        r = mid;
    }
    edges[l].isCycle = true;
}

void dfs(int curr, int beg, int searched)
{
    if(curr == searched){
        foundCycle = true;
        return;
    }
    used[curr] = true;
    for(int i = 0; i < sys[curr].size(); i++){
        int nextu = sys[curr][i].first;
        if(curr == beg && nextu == searched){
            continue;
        }
        if(!used[nextu]){
            dfs(nextu, beg, searched);
        }
        if(foundCycle){
            if(curr < nextu && sys[curr][i].second == false){
                bin_src(curr, nextu);
            }else if(sys[curr][i].second == false){
                bin_src(nextu, curr);
            }
            sys[curr][i].second = true;
            used[curr] = false;
            return;
        }
    }
    used[curr] = false;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n >> m;
    for(int i = 0; i < m; i++){
        cin >> u >> v;
        if(u > v){
            swap(u, v);
        }
        edges.push_back({u, v, false});
        sys[u].push_back({v, false});
        sys[v].push_back({u, false});
    }
    sort(edges.begin(), edges.end());

    for(int i = 0; i < m; i++){
        if(!edges[i].isCycle){
            foundCycle = false;
            dfs(edges[i].s, edges[i].s, edges[i].e);
            if(foundCycle){
                edges[i].isCycle = true;
            }
        }
    }
    for(int i = 0; i < m; i++){
        if(!edges[i].isCycle){
            ans++;
        }
    }
    cout << ans << endl;
return 0;
}
/*
7 8
5 1
1 2
2 6
3 4
4 7
6 7
2 5
3 6
*/
