#include <iostream>
#include <vector>
#include <cstring>
#include <stack>

const int MAX_N = 5e3 + 10;

std::vector<int> nbrs[MAX_N];
std::pair<int, int> list[MAX_N];

int n, m, ans;

bool used[MAX_N];

bool check(int u, int v)
{
    std::stack<int> k;
    k.push(1);
    used[1] = true;
    while(!k.empty())
    {
        int curr = k.top();
        k.pop();
        used[curr] = true;
        for(int i = 0; i < nbrs[curr].size(); ++ i)
        {
            if(curr == u && nbrs[curr][i] == v || (curr == v && nbrs[curr][i] == u))
            {
                continue;
            }
            if(!used[nbrs[curr][i]])
            {
                k.push(nbrs[curr][i]);
            }
        }
    }

    for(int i = 1; i <= n; ++ i)
    {
        if(!used[i])
        {
            return false;
        }
    }
    return true;
}

int main()
{
    std::cin.tie(NULL);
    std::cout.tie(NULL);
    std::ios_base::sync_with_stdio(false);

    std::cin >> n >> m;
    for(int i = 0; i < m; ++ i)
    {
        int u, v;
        std::cin >> u >> v;
        nbrs[u].push_back(v);
        nbrs[v].push_back(u);
        list[i] = {u, v};
    }

    for(int i = 0; i < m; ++ i)
    {
        memset(used, 0, sizeof(used));
        if(!check(list[i].first, list[i].second))
        {
            ++ ans;
        }
    }

    std::cout << ans << '\n';

    return 0;
}
/*
8 9
5 1
1 2
2 6
3 4
4 7
6 7
2 5
3 6
3 8
*/
