#include <iostream>
#include <vector>
#include <cstring>
#include <stack>

const int MAX_N = 5e3 + 10;

std::vector<int> nbrs[MAX_N];
std::pair<int, int> list[MAX_N];

int n, m, ans;

bool used[MAX_N];

void check(int f, int u, int v)
{
    std::stack<int> k;
    k.push(f);
    used[f] = true;
    while(!k.empty())
    {
        int curr = k.top();
        k.pop();
        used[curr] = true;
        for(int i = 0; i < nbrs[curr].size(); ++ i)
        {
            if(curr == u && nbrs[curr][i] == v || (curr == v && nbrs[curr][i] == u))
            {
                continue;
            }
            if(!used[nbrs[curr][i]])
            {
                k.push(nbrs[curr][i]);
            }
        }
    }


}

int main()
{
    std::cin.tie(NULL);
    std::cout.tie(NULL);
    std::ios_base::sync_with_stdio(false);

    std::cin >> n >> m;
    for(int i = 0; i < m; ++ i)
    {
        int u, v;
        std::cin >> u >> v;
        nbrs[u].push_back(v);
        nbrs[v].push_back(u);
        list[i] = {u, v};
    }
    int comp = 0;
    for(int i = 1; i <= n; ++ i)
    {
        if(!used[i])
        {
            ++ comp;
            check(i, 0, 0);
        }
    }

    for(int i = 0; i < m; ++ i)
    {
        memset(used, 0, sizeof(used));
        int c = 0;
        for(int j = 1; j <= n; ++ j)
        {
            if(!used[j])
            {
                ++ c;
                check(j, list[i].first, list[i].second);
            }
        }
        if(c > comp)
        {
            ++ ans;
        }
    }

    std::cout << ans << '\n';

    return 0;
}
/*
8 9
5 1
1 2
2 6
3 4
4 7
6 7
2 5
3 6
3 8
*/
